import processing.core.*; 
import processing.data.*; 
import processing.event.*; 
import processing.opengl.*; 

import ddf.minim.*; 

import java.util.HashMap; 
import java.util.ArrayList; 
import java.io.File; 
import java.io.BufferedReader; 
import java.io.PrintWriter; 
import java.io.InputStream; 
import java.io.OutputStream; 
import java.io.IOException; 

public class SugarHeist extends PApplet {



GameMode gameMode;

//declare IMAGES
PImage lolli, bonbon, schoki;
PImage skyPink, skyLightBlue, skyDarkBlue, universeSky;
PImage glitter, glitterRepulsion;

PImage horizontalClouds, verticalClouds;
PImage goodBubble, badBubble;
PImage heightBackground;
PImage pressPause;


//images for menu
PImage loadingScreen; 
PImage pauseScreen; 
PImage credits;
PImage [] menu=new PImage[7];
PImage [] handbook=new PImage[7];
PImage [] customizeScreen=new PImage[2];
PImage [] gameOverScreen=new PImage[3];


//images for custom font
PImage[] numbers=new PImage[10];
PImage [] letters=new PImage[12];

//images unicorn
PImage [] unicornsBig=new PImage[14];
PImage [] unicornsSmall=new PImage[14];
PImage[] rainbowUnicorn=new PImage[9];

//images for UI
PImage[] rainbowMeter=new PImage[6];
PImage[] rainbowMeterMode=new PImage[9];
PImage [] lives=new PImage[9];


//declare AUDIO files
Minim minim;
AudioPlayer popBubble, glitterSound, badBubblePlop, yay, gameOver, lostHeart, rainbowMeterDing;
AudioPlayer homeScreen, ingame, unicornMode, nightSky_ingame, heartFragment;

//Score variables
int finalScore;
int indexScoreArray = 0;
int indexAllScores = 0;
int highScore = 0;
int[] scoreArray = new int[3];
int[] allScores = new int[30];

//custom Unicorn variables
int indexPlayer1=0;
int indexPlayer2=1;
PImage player1Icon, player2Icon;



public void settings() {

  PJOGL.setIcon("unicornsSmall/11.png");

  //set Screen size
  fullScreen("processing.opengl.PGraphics2D");
  //size(1920, 1080, "processing.opengl.PGraphics2D");
  //size(1280, 720, "processing.opengl.PGraphics2D");
}

public void setup() {
  // set no mouse Cursor
  noCursor();

  frameRate(60);
  surface.setTitle("SugarHeist");


  //load Loading Screen Image
  loadingScreen= loadImage("loadScreen.png");

  image(loadingScreen, 0, 0, width, height);

  for (int i=0; i<unicornsSmall.length; i++) {
    unicornsSmall[i] = loadImage ("unicornsSmall/"+i+".png");
  }

  player1Icon=unicornsSmall[indexPlayer1];
  player2Icon=unicornsSmall[indexPlayer2];



  //Setup Audio Library
  minim = new Minim(this);

  homeScreen = minim.loadFile("sounds/buddy.mp3"); //Royalty Free Soundtrack from bensound "buddy"
  homeScreen.setGain(-15);


  //set StartScreen
  gameMode = new HomeMode();
  homeScreen.play(); //AUDIO
  homeScreen.loop(); //AUDIO
}

boolean needsToPreload=true;

public void draw() {
  //preloads and loads Images 1 time
  if (needsToPreload==true) {
    image(loadingScreen, 0, 0, width, height);
    loadFiles();
    preloadImages();
    needsToPreload=false;
  }

  gameMode.draw();
}


public void mouseClicked() {
  gameMode.mouseClicked();
}
public void keyPressed() {
  gameMode.keyPressed();
}
public void keyReleased() {
  gameMode.keyReleased();
}
public void mousePressed() {
  gameMode.mousePressed();
}
public void mouseReleased() {
  gameMode.mouseReleased();
}



//Image all Images so it works smoothly later
public void preloadImages() {
  for (int i=0; i<numbers.length; i++) {
    image(numbers[i], 0, 0, 0.01f, 0.01f);
  }
  image(loadingScreen, 0, 0, width, height);
  for (int i=0; i<letters.length; i++) {
    image(letters[i], 0, 0, 0.01f, 0.01f);
  }
  image(loadingScreen, 0, 0, width, height);
  for (int i=0; i<rainbowUnicorn.length; i++) {
    image(rainbowUnicorn[i], 0, 0, 0.01f, 0.01f);
  }
  image(loadingScreen, 0, 0, width, height);

  for (int i=0; i<rainbowMeter.length; i++) {
    image(rainbowMeter[i], 0, 0, 0.01f, 0.01f);
  }
  image(loadingScreen, 0, 0, width, height);
  for (int i=0; i<lives.length; i++) {
    image(lives[i], 0, 0, 0.01f, 0.01f);
  }
  image(loadingScreen, 0, 0, width, height);
  for (int i=0; i<rainbowMeterMode.length; i++) {
    image(rainbowMeterMode[i], 0, 0, 0.01f, 0.01f);
  }
  image(loadingScreen, 0, 0, width, height);
  for (int i=0; i<gameOverScreen.length; i++) {
    image(gameOverScreen[i], 0, 0, 0.01f, 0.01f);
  }
  image(loadingScreen, 0, 0, width, height);
}


//load all data
public void loadFiles() {

  //IMAGE FILES
  bonbon = loadImage ("bonbon.png");
  lolli = loadImage ("lolli.png");
  schoki = loadImage ("schoki.png");

  skyPink = loadImage ("rosaSky.jpg");
  skyLightBlue= loadImage ("blueSky.jpg");
  skyDarkBlue= loadImage ("nightSky.jpg");
  universeSky= loadImage("universeSky.jpg");

  heightBackground= loadImage("heightBackground.png");
pressPause= loadImage("pressPause.png");

  pauseScreen= loadImage("pauseScreen.png");
  credits=loadImage ("menu/credits.png");


  glitter = loadImage ("glitter.png");
  glitterRepulsion = loadImage ("glitterRepulsion.png");


  horizontalClouds = loadImage ("horizontalClouds.png");
  verticalClouds = loadImage ("verticalClouds.png");
  badBubble = loadImage ("badBubble.png");
  goodBubble = loadImage ("goodBubble.png");

  for (int i=0; i<rainbowUnicorn.length; i++) {
    rainbowUnicorn[i] = loadImage ("rainbowUnicorn/"+i+".png");
  }

  for (int i=0; i<rainbowMeter.length; i++) {
    rainbowMeter[i] = loadImage ("rainbowMeter/"+i+".png");
  }
  for (int i=0; i<lives.length; i++) {
    lives[i] = loadImage ("lives/"+i+".png");
  }
  for (int i=0; i<rainbowMeterMode.length; i++) {
    rainbowMeterMode[i] = loadImage ("rainbowMeter/rainbowMeterMode/"+i+".png");
  }

  for (int i=0; i<numbers.length; i++) {
    numbers[i] = loadImage ("numbers/"+i+".png");
  }
  for (int i=0; i<letters.length; i++) {
    letters[i] = loadImage ("letters/"+i+".png");
  }

  for (int i=0; i<menu.length; i++) {
    menu[i] = loadImage ("menu/"+i+".png");
  }
  for (int i=0; i<handbook.length; i++) {
    handbook[i] = loadImage ("handbook/"+i+".png");
  }

  for (int i=0; i<gameOverScreen.length; i++) {
    gameOverScreen[i] = loadImage ("gameOver/"+i+".png");
  }

  for (int i=0; i<customizeScreen.length; i++) {
    customizeScreen[i] = loadImage ("customizeScreen/"+i+".png");
  }

  // AUDIO FILES and set Gain
  popBubble = minim.loadFile("sounds/plop.mp3");
  popBubble.setGain(12);
  glitterSound = minim.loadFile ("sounds/glitter.mp3");
  glitterSound.setGain(-20);
  badBubblePlop = minim.loadFile ("sounds/badBubbleplop.mp3");
  unicornMode=minim.loadFile("sounds/PFUDOR_.mp3"); //Common License Soundtrack from bensounds "happy rock"
  unicornMode.setGain(-11);

  ingame = minim.loadFile("sounds/sunny.mp3"); //Common License Soundtrack from bensounds "sunny"
  ingame.setGain(-15);
  yay = minim.loadFile("sounds/yay.mp3"); //later use as audio for the extra heart gain
  yay.setGain(+20);
  gameOver = minim.loadFile("sounds/gameOver.mp3");
  gameOver.setGain(-15);
  lostHeart = minim.loadFile("sounds/losing_a_heart.mp3");
  lostHeart.setGain(-10);
  rainbowMeterDing = minim.loadFile("sounds/airplane_beep.mp3"); //Sponsored by Airplane Sounds from Lufthansa
  rainbowMeterDing.setGain (-9);
  nightSky_ingame = minim.loadFile ("sounds/cute.mp3"); //Common License Soundtrack from bensounds "cute"
  nightSky_ingame.setGain(-10);
  heartFragment = minim.loadFile ("sounds/heartFragment.mp3"); 
  heartFragment.setGain (-6);
}
abstract class GameMode {
  public void draw() {
  }
  public void mouseClicked() {
  }
  public void keyPressed() {
  }
  public void keyReleased() {
  }
  public void mousePressed() {
  }
  public void mouseReleased() {
  }
}

//MODE with menu
class HomeMode extends GameMode {
  boolean showsCredits=false;
  int selection=1;

  public void draw() { 
    image(menu[0], 0, 0, width, height);
    image(menu[6], 0, 0, width, height);
    image(menu[selection], 0, 0, width, height);
    if (showsCredits==true) {
      image(credits, 0, 0, width, height);
    }
  }

  public void keyPressed() {
    if (showsCredits==true) {
      showsCredits=false;
    }

    //coordinate in menu
    if (keyCode==DOWN) {
      selection++;
      
      if (selection>5) {
        selection=1;
      }
    } else if (keyCode==UP) {
      selection--;
     
      if (selection<1) {
        selection=5;
      }

      //select a menu point
    } else if (keyCode==ENTER) {
      switch(selection) {
      case 1:
        gameMode=new GameLoadsMode();
        break;
      case 2:
        gameMode =new Handbook();
        break;
      case 3:
        gameMode=new CustomizeMode();
        break;
      case 4:
        showsCredits=true;
        break;
      case 5:
        exit();
        break;
      }
    }
  }
}

//loading Screen while Game is loading
class GameLoadsMode extends GameMode {
  int counter=0;

  public void draw() {
    image(loadingScreen, 0, 0, width, height);
  }
  public void keyReleased() {
    //start Game
    delay(300);
    gameMode = new UnicornGame();
  }
}

// MODE for Game Over
class GameEndsMode extends GameMode {
  int selection=1;

  GameEndsMode() {
    ingame.pause(); //AUDIO
    ingame.rewind(); //AUDIO
    nightSky_ingame.pause(); //AUDIO
    nightSky_ingame.rewind(); //AUDIO
    gameOver.play(); //AUDIO
    gameOver.rewind(); //AUDIO
  }

  public void draw() { 

    image(gameOverScreen[0], 0, 0, width, height);

    //coordinate on Game Over Screen
    switch(selection) {
    case 1:
      image(gameOverScreen[selection], 0, 0, width, height);
      break;
    case 2:
      image(gameOverScreen[selection], 0, 0, width, height);
      break;
    }

    //display Score
    imageMode(CENTER);
    displayScore(); 
    imageMode(CORNER);
  }

  public void keyPressed() {

    //coordinate in menu
    if (keyCode==LEFT) {
      selection--;
      if (selection<1) {
        selection=2;
      }
    }
    if (keyCode==RIGHT) {
      selection++;
      if (selection>2) {
        selection=1;
      }
    }

    //select a menu point
    if (keyCode==ENTER) {

      switch(selection) { 
      case 1:
        delay(500);
        gameMode=new UnicornGame();
        break;
      case 2:
        delay(500);
        gameMode=new HomeMode();
        homeScreen.rewind(); //AUDIO
        homeScreen.play(); //AUDIO
        homeScreen.loop(); //AUDIO
        break;
      }
    }
  }
}

//MODE for instruction handbook
class Handbook extends GameMode {
  int selection=0;

  Handbook() {
  }

  public void draw() {
    image(handbook[selection], 0, 0, width, height);
  }

  public void keyPressed() {
    //coordinate in handbook
    if (keyCode==LEFT) {
      selection--;

      if (selection<0) {
        selection=0;
      }
    }
    if (keyCode==RIGHT) {   
      selection++;
    }

    //get back to home menu
    if (selection>=7) {
      gameMode=new HomeMode();
    }
  }
}

//MODE to customize unicorn
class CustomizeMode extends GameMode {

  int selection1=indexPlayer1;
  int selection2=indexPlayer2;

  CustomizeMode() {
    //load unicorn Images in higher Resolution
    for (int i=0; i<unicornsBig.length; i++) {
      unicornsBig[i] = loadImage ("unicornsBig/"+i+".png");
    }
  }
  public void draw() {
    image(customizeScreen[0], 0, 0, width, height);
    image(customizeScreen[1], 0, 0, width, height);


    //image unicorn in selected color
    imageMode(CENTER);
    image(unicornsBig[selection1], width/4+width/2, height/12+height/2, width/4.8f, width/4.8f);
    image(unicornsBig[selection2], width/4, height/12+height/2, width/4.8f, width/4.8f);
    imageMode(CORNER);
  }

  public void keyPressed() {
    //coordinate in menu player1
    if (keyCode==RIGHT) {
      selection1++;
      if (selection1==selection2) {
        selection1++;
      }
      if (selection1>13) {  
        selection1=0;
      }
    }
    if (keyCode==LEFT) {
      selection1--;
      if (selection1==selection2) {
        selection1--;
      }
      if (selection1<0) {  
        selection1=13;
      }
    }

    //coordinate in menu player2
    if (keyCode=='d'||keyCode=='D') {
      selection2++;
      if (selection2==selection1) {
        selection2++;
      }
      if (selection2>13) {  
        selection2=0;
      }
    }
    if (keyCode=='a'||keyCode=='A') {
      selection2--;
      if (selection2==selection1) {
        selection2--;
      }
      if (selection2<0) {  
        selection2=13;
      }
    }

    //confirm selection and set player icons
    if (keyCode==ENTER) {
      indexPlayer1=selection1;
      indexPlayer2=selection2;

      player1Icon=unicornsSmall[indexPlayer1];
      player2Icon=unicornsSmall[indexPlayer2];

      gameMode=new HomeMode();
    }
  }
}

//image score in correct coordinates
public void displayScore() {  
  drawScore(highScore, width/3.12f, height/1.136f, width/27.42f);
  drawScore(scoreArray[0], width/5.2f, height/5.14f, width/29.54f);
  drawScore(scoreArray[1], width/13.24f, height/2.117f, width/34.91f);
  drawScore(scoreArray[2], width/4, height/1.66f, width/42.6666f);
}

//calculate correct Images and local coordinates for the score
public void drawScore(int scoreValue, float x, float y, float size) {
  int onesPlace=(scoreValue%10)/1;
  int tensPlace=(scoreValue%100-onesPlace)/10;
  int hundredsPlace=(scoreValue%1000-onesPlace-tensPlace)/100;
  int thousandsPlace=(scoreValue%10000-onesPlace-tensPlace-hundredsPlace)/1000;
  int tenThousandsPlace=(scoreValue%100000-onesPlace-tensPlace-hundredsPlace-thousandsPlace)/10000;
  float x1 = x + (size-(size/4)) * 5;
  float x2 = x + (size-(size/4)) * 4;
  float x3 = x + (size-(size/4)) * 3;
  float x4 = x + (size-(size/4)) * 2;
  float x5 = x + (size-(size/4));
  float xm = x + (size-(size/5)) * 6;

  imageMode(CENTER);
  image(letters[6], xm, y, size, size);
  if (scoreValue<10) {
    image(numbers[onesPlace], x1, y, size, size);
  }
  if (scoreValue<100&&scoreValue>=10) { 
    image(numbers[onesPlace], x1, y, size, size);
    image(numbers[tensPlace], x2, y, size, size);
  }
  if (scoreValue<1000&&scoreValue>=100) { 
    image(numbers[onesPlace], x1, y, size, size);
    image(numbers[tensPlace], x2, y, size, size);
    image(numbers[hundredsPlace], x3, y, size, size);
  }
  if (scoreValue<10000&&scoreValue>=1000) { 
    image(numbers[onesPlace], x1, y, size, size);
    image(numbers[tensPlace], x2, y, size, size);
    image(numbers[hundredsPlace], x3, y, size, size);
    image(numbers[thousandsPlace], x4, y, size, size);
  }
  if (scoreValue<100000&&scoreValue>=10000) { 
    image(numbers[onesPlace], x1, y, size, size);
    image(numbers[tensPlace], x2, y, size, size);
    image(numbers[hundredsPlace], x3, y, size, size);
    image(numbers[thousandsPlace], x4, y, size, size);
    image(numbers[tenThousandsPlace], x5, y, size, size);
  }
  imageMode(CORNER);
}

static final float MIN_COLLISION_EPSILON = 0.0001f;
static int lastUsedObjectID = 0;
int wPressed = 'w';
int aPressed = 'a';
int sPressed = 's';
int dPressed = 'd';
int noPressed;
int downPressed = DOWN;
int upPressed = UP;
int rightPressed = RIGHT;
int leftPressed = LEFT;

abstract class GameObject {


  GameWorld gameWorld;
  int objectID;

  GameObject(GameWorld _gameWorld) {
    objectID = lastUsedObjectID++;
    gameWorld = _gameWorld;
  }

  /** default physics: unmovable object, does not do a thing */

  public void updateA(float deltaTimeSeconds) {
  }
  public void updateV(float deltaTimeSeconds) {
  }
  public void updateS(float deltaTimeSeconds) {
  }
  public void handleCollisions(float deltaTimeSeconds) {
  }

  public abstract void draw();
}

abstract class SphericalGameObject extends GameObject {

  PVector s, v, a; //!< in meters. coordinate system: 0,0 is top-left. Location s, velocity v, acceleration a.
  PVector gravity, gravity_TO_PLAYER;
  float radius; // in meters
  int sphereColor;
  float dampingFactor = 0.15f; //!<  > 0; relative amount of velocity retained after 1 second (1.0 == no damping)
  float mass = 0.01f;

  SphericalGameObject(GameWorld _gameWorld, float x, float y, float _radius) {
    super(_gameWorld);
    radius = _radius;

    s = new PVector(x, y);
    v = new PVector(0.0f, 0.0f);
    a = new PVector(0.0f, 0.0f);

    gravity = new PVector (-0.00098f, 0.00098f);  //gravity-vector for the bottom-left corner
  }

  public void updateA(float deltaTimeSeconds) {
  }

  public void updateV(float deltaTimeSeconds) {
    v.add(PVector.mult(a, deltaTimeSeconds));
    v.mult(pow(dampingFactor, deltaTimeSeconds));
  }

  public void updateS(float deltaTimeSeconds) {
    s.add(PVector.mult(v, deltaTimeSeconds)).add(PVector.mult(a, -0.5f*deltaTimeSeconds*deltaTimeSeconds));
  }

  public void handleCollisions(float deltaTimeSeconds) {
    for (GameObject o : gameWorld.gameObjects) {
      if (o instanceof WorldBoundary) {
        handleWorldBoundaryCollision((WorldBoundary) o, deltaTimeSeconds);
      } else if (o instanceof SphericalGameObject) {
        handleSphericalGameObjectCollision((SphericalGameObject) o, deltaTimeSeconds);
      } else if (o instanceof Glitter) {
        handleSphericalGameObjectCollision((Glitter) o, deltaTimeSeconds);
      }
    }
  }

  public void handleSphericalGameObjectCollision(SphericalGameObject sgo, float deltaTimeSeconds) {
  }


  //handle Collision with Boundaries
  public void handleWorldBoundaryCollision(WorldBoundary wb, float deltaTimeSeconds) {
    if (this instanceof Unicorn) {
      if ((s.y<0.05f)||(s.x>gameWorld.worldWidthMeters-0.05f)) { 
        float vdotn = PVector.dot(v.normalize().mult(0.5f), wb.n);

        PVector vold = v.copy().normalize().mult(0.5f);
        v.sub(PVector.mult(wb.n, 3.0f * vdotn));
        s.add(PVector.mult(vold, -deltaTimeSeconds));
        s.add(PVector.mult(v.normalize().mult(0.5f), deltaTimeSeconds));
      }
      //saves the unicorn
      if (s.y<0.04f) {
        s.y=0.25f;
      }
      if (s.x>gameWorld.worldWidthMeters-0.04f) {
        s.x=gameWorld.worldWidthMeters-0.25f;
      }
    }
  }
}

abstract class Bubble extends SphericalGameObject {
  int counter=0;
  boolean popped;
  float startSpeed;

  Bubble(GameWorld _gameWorld, float x, float y, float _radius, boolean popped) {
    super(_gameWorld, x, y, _radius);
    this.popped=popped;
    this.startSpeed=0.05f;
  }
  public void updateA(float deltaTimeSeconds) {
    a=new PVector(-0.5f*gameWorld.updateSpeed, 0.5f*gameWorld.updateSpeed);
  }
  public void updateV(float deltaTimeSeconds) {
    gameWorld.speed=startSpeed*gameWorld.updateSpeed;
    a=new PVector(-0.5f*gameWorld.updateSpeed, 0.5f*gameWorld.updateSpeed);
    a.mult(0.03f*gameWorld.updateSpeed);
    v.add(PVector.mult(a, deltaTimeSeconds));

    //limit speed of bubbles
    if (v.mag()>gameWorld.speed) {
      v.setMag(gameWorld.speed);
    }
  }
  public void updateS(float deltaTimeSeconds) {
    s.add(PVector.mult(v, deltaTimeSeconds).add(PVector.mult(a, 0.5f).mult(deltaTimeSeconds).mult(deltaTimeSeconds)));

    //pulse bubble
    counter++;
    if (counter<=500&&counter>250) {
      radius+=0.0002f;
      if (counter==500) {
        counter=0;
      }
    }
    if (counter<=250) {
      radius-=0.0002f;
    }
  }
  public abstract void draw();
}
class GoodBubble extends Bubble {
  Sweet sweet;

  GoodBubble(GameWorld _gameWorld, float x, float y, float _radius, boolean _popped, Sweet _sweet) {
    super(_gameWorld, x, y, _radius, _popped);
    this.sweet=_sweet;
  }

  public void handleSphericalGameObjectCollision(SphericalGameObject sgo, 
    float deltaTimeSeconds) {

    if (! (sgo instanceof Unicorn)||this.popped==true) { // we are only interested in Bubble-Unicorn collisions
      return;
    }
    if (PVector.dist(sgo.s, s) < sgo.radius+radius-0.09f) {
      this.popped=true;
      this.sweet.withoutBubble=true;
      gameWorld.bubbleCounter--;


      popBubble.play();  //AUDIO
      popBubble.rewind(); //AUDIO
    }
  }


  public void draw() {
    noStroke();
    imageMode(CENTER);
    image(goodBubble, s.x, s.y, radius+0.2f, radius+0.2f);
    imageMode(CORNER);

    sweet.updatePos(s.x, s.y);
  }
}

class BadBubble extends Bubble {

  BadBubble(GameWorld _gameWorld, float x, float y, float _radius, boolean _popped) {
    super(_gameWorld, x, y, _radius, _popped);
  }

  public void handleSphericalGameObjectCollision(SphericalGameObject sgo, 
    float deltaTimeSeconds) {        
    if (! (sgo instanceof Unicorn)||this.popped==true) { // we are only interested in Bubble-Unicorn collisions
      return;
    }
    if (PVector.dist(sgo.s, this.s) < sgo.radius+radius-0.09f) {
      if (gameWorld.saveRespawn==false) {
        this.popped=true;
        gameWorld.bubbleCounter--;
        //losing heart when popping a "Bad Bubble"
        if (gameWorld.rainbowMode==false) {
          badBubblePlop.play(); //AUDIO
          badBubblePlop.rewind(); //AUDIO
          gameWorld.lives--;
          lostHeart.play(); //AUDIO
          lostHeart.rewind(); //AUDIO
        } else {
          popBubble.play(); //AUDIO
          popBubble.rewind(); //AUDIO
        }
      }
    }
  }

  public void draw() {
    imageMode(CENTER);
    image(badBubble, s.x, s.y, radius+0.2f, radius+0.2f);
    imageMode(CORNER);
  }
}
class Sweet extends SphericalGameObject {
  float randomIcon= random(0, 3);
  boolean withoutBubble=false;


  Sweet(GameWorld _gameWorld, float x, float y, float _radius) {
    super(_gameWorld, x, y, _radius);
  }

  public void updatePos(float x, float y) {//positioned in middle of bubble
    s.x=x-radius/2;
    s.y=y-radius/2;
  }

  public void updateA(float deltaTimeSeconds) {
    if (withoutBubble==true) {
      //calculate Vector between Seet and heartPos, then normalize and increase it
      a=new PVector((0.15f-s.x),(0.15f-s.y)).normalize().mult(4);
    }
  }

  public void updateV(float deltaTimeSeconds) {
    if (withoutBubble==true) {
      v.add(PVector.mult(a, deltaTimeSeconds));
      v.mult(pow(dampingFactor, deltaTimeSeconds));
    }
  }

  public void updateS(float deltaTimeSeconds) {
    if (withoutBubble==true) {
      s.add(PVector.mult(v, deltaTimeSeconds)).add(PVector.mult(a, -0.5f*deltaTimeSeconds*deltaTimeSeconds));
    }
  }
  public void draw() {
    //draws random sweet
    if (randomIcon<1) {
      image(lolli, s.x, s.y, radius, radius);
    } else if (randomIcon<2) {
      image(schoki, s.x, s.y, radius, radius);
    } else if (randomIcon<3) {
      image(bonbon, s.x, s.y, radius, radius);
    }
  }
}


// moving Background
class Background extends GameObject {
  PVector s, v, a, startPos;
  float repeatWidth; // when should the image be repeated
  float startSpeed=0.02f;

  int alphaPink=255, alphaLightBlue=255, alphaDarkBlue=255;
  int lightBlueHeight=350, darkBlueHeight=1100, starHeight=2000;//when does the background change

  Background(GameWorld _gameWorld, PVector _startPos) {
    super(_gameWorld);
    startPos=_startPos.copy();
    s = startPos.copy();
    v = new PVector(0.0f, 0.0f);
    a = new PVector(0.0f, 0.0f);
    repeatWidth = gameWorld.worldHeightMeters;
  }

  public void updateV(float deltaTimeSeconds) {
    gameWorld.speed=startSpeed*gameWorld.updateSpeed;//increses speed over time
    v=new PVector(-gameWorld.speed*gameWorld.worldWidthMeters, gameWorld.speed*gameWorld.worldHeightMeters);
  }
  public void updateS(float deltaTimeSeconds) {
    s.add(PVector.mult(v, deltaTimeSeconds).add(PVector.mult(a, 0.5f).mult(deltaTimeSeconds).mult(deltaTimeSeconds)));
  }

  public void draw () { 

    //set background according to gameHeigth
    image(universeSky, s.x, s.y-gameWorld.worldHeightMeters, gameWorld.worldWidthMeters*2, gameWorld.worldHeightMeters*2);
    if (gameWorld.gameHeight>=starHeight) {
      tint(255, alphaDarkBlue);

      if (alphaDarkBlue>=0) {
        alphaDarkBlue--;
      }
    }

    image(skyDarkBlue, s.x, s.y-gameWorld.worldHeightMeters, gameWorld.worldWidthMeters*2, gameWorld.worldHeightMeters*2);

    //fade between day and night music
    if (gameWorld.gameHeight==darkBlueHeight-4) ingame.setGain(-16);
    if (gameWorld.gameHeight==darkBlueHeight-2) ingame.setGain(-22);
    if (gameWorld.gameHeight==darkBlueHeight) ingame.setGain(-28);
    if (gameWorld.gameHeight==darkBlueHeight+2) ingame.setGain(-34);
    if (gameWorld.gameHeight==darkBlueHeight+4) ingame.setGain(-40);

    if (gameWorld.gameHeight==darkBlueHeight) {
      nightSky_ingame.play(); //AUDIO
      nightSky_ingame.loop(); //AUDIO
      if (gameWorld.rainbowMode==true) {
        nightSky_ingame.mute(); //AUDIO
      }
    }
    if (gameWorld.gameHeight>=darkBlueHeight) {
      tint(255, alphaLightBlue);

      if (alphaLightBlue>=0) {
        alphaLightBlue--;
        ingame.pause(); //AUDIO
        ingame.setGain (-10); //AUDIO
        ingame.rewind(); //AUDIO
      }
    }
    image(skyLightBlue, s.x, s.y-gameWorld.worldHeightMeters, gameWorld.worldWidthMeters*2, gameWorld.worldHeightMeters*2);
    noTint();
    if (gameWorld.gameHeight>=lightBlueHeight) {
      tint(255, alphaPink);
      if (alphaPink>=0) {
        alphaPink--;
      }
    }
    image(skyPink, s.x, s.y-gameWorld.worldHeightMeters, gameWorld.worldWidthMeters*2, gameWorld.worldHeightMeters*2);
    noTint();


    //set Image to the beginning
    if (s.y > (startPos.y+repeatWidth)) {
      s = startPos.copy(); //Set imagePos to startPos
    }
  }
}


//Edges of the World :)
class WorldBoundary extends GameObject {

  PVector pA, pB; // points A and B on the Line  
  PVector n; // normal
  float d; // distance origin-plane, for Hessian normal form


  WorldBoundary(GameWorld _gameWorld, PVector _pA, PVector _pB) {
    super(_gameWorld);
    // copy the contents, so that we do not have an external reference into our internal data structures
    pA = _pA.copy();
    pB = _pB.copy();
    PVector u = PVector.sub(pB, pA);
    n = new PVector(u.y, -u.x);
    n.normalize();
    d = PVector.dot(n, pA);
  }

  public void draw() {
    image(horizontalClouds, 0, -1.4f, gameWorld.worldWidthMeters, gameWorld.worldHeightMeters);
    image(verticalClouds, 2.3f, 0, gameWorld.worldWidthMeters, gameWorld.worldHeightMeters);
  }
}
//springs calculated with hooke's law
 
/*credits: to Daniel Shiffman (amazing tutorials on youtube about game physics)
The spring code is based on one of Daniel Shiffmans examples form the book Nature of Code. Also I have read this chapter quite often to understand the physics behind springs.
https://github.com/nature-of-code/noc-examples-processing/tree/master/chp03_oscillation/Exercise_3_16_springs_array
*/

//springs calculated with hooke's law
class Spring extends GameObject {

  // position
  PVector anchor;

  // Rest length and spring constant
  float len;
  float k = 0.18f;

  Unicorn a;
  Unicorn b;

  // Constructor
  Spring(GameWorld _gameWorld, Unicorn a_, Unicorn b_, float l) {
    super(_gameWorld);
    a = a_;
    b = b_;
    len = l;
  } 

  // Calculate spring force
  public void update(float deltaTimeSeconds) {
    if(gameWorld.rainbowMode==true){
      k=25;
    }else{
      k = 0.18f;
    }
    // Vector pointing from one unicorn to the other
    PVector force = PVector.sub(a.s, b.s);
    // What is distance
    float d = force.mag();
    float stretch = d - len;
      // Stretch is difference between current distance and rest length
      // Calculate force according to Hooke's Law
      // F = k * stretch
      force.normalize();
      force.mult(-1 * k * stretch * 0.01f);
      a.applyForce(force, deltaTimeSeconds);
      force.mult(-1);
      b.applyForce(force, deltaTimeSeconds);
   }
   
  public void draw() {
  }
}

// Glitter is our AI 
// In its normal state it is drawn to the player. Is the player too close to the glitter it moves away

/*Credits to Prof. Fuchs: most of the code is from the example "floyd the boid" in chapter AI 1 in Übungen Games*/

class Glitter extends SphericalGameObject {

  PVector s, v, a; //!< in meters. coordinate system: 0,0 is top-center. Location s, velocity v, acceleration a
  float radius; // in meters
  int glitterColor;
  float mass = 0.1f;
  boolean popped;
  PImage glitterImage;

  //behavioral attributes
  PVector destination;//the coordinates, at which glitter is drawn to, random
  float turnRate = 0.5f; // in rad/s
  float maxAcceleration = 0.6f;
  float repulsionAmount = 2.0f;
  float attractionAmount = 2.0f;
  float repulsionVisibilityRadius = 1.0f; 
  float attractionVisibilityRadius = 2.0f; 
  float cosAngleOfMaximalVisibility = -1;
  float directionalInfluence = 0.01f; 
  float destinationAcceleration = 1;
  float maxVelocity = 0.35f; 

  int currentStatus = 0;
  final int ATTRACTION = 0;
  final int REPULSION = 1;

  PVector alignmentOfNearbyGlitter;

  Glitter(GameWorld _gameWorld, float x, float y, float _radius, PImage _glitterImage) {
    super(_gameWorld, x, y, _radius);
    radius = _radius;
    s = new PVector(x, y);
    float angle = random(2.0f*PI); //Random orientation
    v = new PVector(cos(angle)*0.001f, sin(angle)*0.001f);
    a = new PVector(0.0f, 0.0f);
    alignmentOfNearbyGlitter = new PVector(0.0f, 0.0f);

    glitterImage = _glitterImage; 

    destination = new PVector(random(gameWorld.worldWidthMeters), random(gameWorld.worldHeightMeters));
  }
  
  //State change - if glitter gets into REPULSION state it changes color

  public void updateColor(int currentStatus) { 
    switch (currentStatus) {

    case ATTRACTION:
      glitterImage = glitter;
      glitterColor = 0;
      break;
    case REPULSION: 
      glitterImage = glitterRepulsion;
      break;
    }
  }

  public void updateA(float deltaTimeSeconds) {

    a = PVector.sub(destination, s);
    a.mult(destinationAcceleration);

    //avoid Unicorn destination 
    PVector localDir1 = PVector.sub(gameWorld.player1.s, s);
    float distance1 = PVector.sub(gameWorld.player1.s, s).mag();

    attractionAndRepulsion(localDir1, distance1);

    PVector localDir2 = PVector.sub(gameWorld.player2.s, s);
    float distance2 = PVector.sub(gameWorld.player2.s, s).mag();

    attractionAndRepulsion(localDir2, distance2);
  }
  
  public void attractionAndRepulsion(PVector direction, float length) {
    if (length > EPSILON) {   
      direction.mult(1.0f/length);
      PVector orientation = direction.copy().normalize();
      float cosBetweenOrientations = orientation.dot(v.copy().normalize());
      if (cosBetweenOrientations >= cosAngleOfMaximalVisibility && length <= repulsionVisibilityRadius) { 
        a.add(PVector.mult(direction, -1 * attractionAmount * pow(length, -4)));
        destination = new PVector(random(gameWorld.worldWidthMeters), random(gameWorld.worldHeightMeters));
        updateColor(REPULSION);
      } else if (cosBetweenOrientations >= cosAngleOfMaximalVisibility && length >= attractionVisibilityRadius) { 
        a.add(PVector.mult(direction, repulsionAmount * pow(length, -2)));
        updateColor(ATTRACTION);
      }
      a.mult(min(1.0f, maxAcceleration / a.mag()));
    }
  }

  public void updateV(float deltaTimeSeconds) {
    limitTurnRate(PVector.add(v, PVector.mult(a, deltaTimeSeconds)).add(alignmentOfNearbyGlitter.mult(directionalInfluence * v.mag())), deltaTimeSeconds);
    // speed limit
    v.mult(min(1.0f, maxVelocity / v.mag()));
  }

  public void updateS(float deltaTimeSeconds) {
    s.add(PVector.mult(v, deltaTimeSeconds)).add(PVector.mult(a, -0.5f*deltaTimeSeconds*deltaTimeSeconds));
  }

  public void computeOtherBoidsAlignment() {
    
    alignmentOfNearbyGlitter.x = 0;
    alignmentOfNearbyGlitter.y = 0;

    for (GameObject o : gameWorld.gameObjects) {
      if (o instanceof Glitter) {
        Glitter b= (Glitter) o;
        PVector localDir = PVector.sub(s, b.s);
        float localLength = localDir.mag();
        if (localLength > EPSILON && localLength <= attractionVisibilityRadius) {
          PVector orientation = localDir.copy().normalize();
          float cosBetweenOrientations = orientation.dot(v.copy().normalize());
          if (cosBetweenOrientations >= cosAngleOfMaximalVisibility) {
            alignmentOfNearbyGlitter.add(b.v.copy().normalize());
          }
        }
      }
    }
  }

// Glitter/ Unicorn collision. 
  public void handleSphericalGameObjectCollision(SphericalGameObject sgo, 
    float deltaTimeSeconds) {
    if (! (sgo instanceof Glitter)) { 
      if (! (sgo instanceof Unicorn)||this.popped==true) { // we are only interested in Glitter-Unicorn collisions
        return;
      } else if (PVector.dist(sgo.s, this.s) < (sgo.radius+radius-0.13f)&&gameWorld.saveRespawn==false) {
        this.popped = true;
        gameWorld.glitterCounter--;

        if (gameWorld.glitterScore<gameWorld.maxGlitterScore) {
          gameWorld.glitterScore++;
          glitterSound.play(); //AUDIO
          glitterSound.rewind(); //AUDIO
        }
      }
      return;
    }
  }

  public void limitTurnRate(PVector newV, float deltaTimeSeconds) {

    PVector desiredOrientation = newV.copy().normalize();
    float desiredLength = newV.mag();

    float desiredOrientationAngle = atan2(desiredOrientation.y, desiredOrientation.x);
    float orientationAngle = atan2(v.y, v.x);
    float delta = desiredOrientationAngle - orientationAngle;

    if (delta > PI) { // the other way is closer
      delta = -2.0f * PI + delta;
    } else if (delta < -PI) {
      delta = 2.0f * PI + delta;
    }

    // limit turn rate
    delta = min(max(delta, -turnRate), turnRate * deltaTimeSeconds);

    orientationAngle += delta;

    v.x = cos(orientationAngle) * desiredLength;
    v.y = sin(orientationAngle) * desiredLength;
  }



  public void draw() {

    imageMode(CENTER);
    image(glitterImage, s.x, s.y, radius, radius);
    imageMode(CORNER);
  }
}
class GameWorld { 

  //measurments of the GameWorld
  final float worldWidthMeters = 4;
  final float worldHeightMeters = 2.25f;

  final float HOOKES_CONSTANT= 0.05f;
  float goodBadBubbleRatio=0.4f;

  //variables for lives
  int lives=3;
  int maxLives=3;

  //variables for bubbles
  int numberOfBubbles=14;
  int bubbleScore=0;
  int bubbleCounter=0; //counts number Of bubbles
  int bubbleRatioCounter=1;

  //starting positions for unicorns
  PVector startPosP1=new PVector(worldWidthMeters/2, worldHeightMeters/2);
  PVector startPosP2=new PVector(worldWidthMeters/3, worldHeightMeters/2);

  boolean[] keys = new boolean[255];

  // Controls to move unicorns 
  int wPressed = 'w', aPressed = 'a', sPressed = 's', dPressed = 'd';
  int noPressed;
  int upPressed = UP, downPressed = DOWN, leftPressed = LEFT, rightPressed = RIGHT;

  //variables for save respawn
  float saveRespawnTime=0;
  boolean saveRespawn=false;

  //variables for RainbowMode
  boolean rainbowMode=false;
  int rainbowSpeed=8;
  float rainbowTime=0; 
  int pulseCounter=0;//how the rainbowMeter pulses

  //variables for Glitter
  int glitterScore=0; //current glitter score
  int maxGlitterScore=5; //how many glitter you need to get in the rainbowMode
  int glitterCounter=0; //how many glitters are in the game
  int maxAmountOfGlitter=18;//how many glitters should be in the game at all times

  //current game height (score)
  int gameHeight=0;

  float updateSpeed=1;

  float gamePausedTime=0;

  float speed=0;


  java.util.LinkedList<GameObject> gameObjects;   // list with all game objects

  //Spring force
  Spring s1;
  Spring s2;
  //2 Players
  Unicorn player1;
  Unicorn player2;
  //sweets
  Sweet[] sweets;
  //Background
  Background background;


  GameWorld() {

    // creating a list containing all gameobjects
    gameObjects = new java.util.LinkedList<GameObject>();

    // construct a default scene by creating gameObjects
    background = new Background(this, new PVector(0, 0));

    player1 = new Unicorn(this, startPosP1.x, startPosP1.y, player1Icon);
    player2 = new Unicorn(this, startPosP2.x, startPosP2.y, player2Icon);

//Spring between players, length: 0.1 meter
    s1 = new Spring(this, player1, player2, 0.15f);
    s2 = new Spring(this, player2, player1, 0.15f);

    //adding background before everything else
    gameObjects.add(background);


    //spawn random bubbles without overlapping
    for (int i=0; i<numberOfBubbles; i++) {
      println(i);

      float x = random(worldWidthMeters);      
      float y = random(worldHeightMeters);
      float radius=random(0.2f, 0.3f);

      //try to place Bubbles and stop if not possible
    attempts: 
      for (int attempts=0; attempts<20; attempts++) {
        for (GameObject o : gameObjects) {
          if (o instanceof Bubble) {
            Bubble bubble= (Bubble) o;
            //calculate distance between Bubble and Bubble and between Player and Bubble
            double bubbleDistance = Math.sqrt((bubble.s.x-x)*(bubble.s.x-x)+(bubble.s.y-y)*(bubble.s.y-y));
            double player1Distance= Math.sqrt((startPosP1.x-x)*(startPosP1.x-x)+(startPosP1.y-y)*(startPosP1.y-y));
            double player2Distance= Math.sqrt((startPosP2.x-x)*(startPosP2.x-x)+(startPosP2.y-y)*(startPosP2.y-y));

            if (bubbleDistance<=(radius+bubble.radius+0.05f)||player1Distance<=(radius+player1.radius+0.25f)||player2Distance<=(radius+player2.radius+0.25f)) {
              //new Position, if Bubble overlaps with player/ other Bubbles
              x = random(worldWidthMeters);      
              y=  random(worldHeightMeters);
              continue attempts;
            }
          }
        }
        if (i<numberOfBubbles*goodBadBubbleRatio) {
          gameObjects.add(new BadBubble(this, x, y, radius, false));
          bubbleCounter++;
          break;
        } else {
          Sweet sweet=new Sweet(this, x+radius/2, y-radius/2, 0.3f);  
          gameObjects.add(new GoodBubble(this, x, y, radius, false, sweet));
          gameObjects.add(sweet);
          bubbleCounter++;
          break;
        }
      }
    }

    //spawn random glitter
    for (int i = 0; i < maxAmountOfGlitter; ++i) {
      float x = random(worldWidthMeters);      
      float y = random(worldHeightMeters);
      float radius= 0.15f;
      PImage glitterImage = glitter;
      gameObjects.add(new Glitter(this, x, y, radius, glitterImage));
      glitterCounter++;
    }

    //add the other GameObjects to the list
    gameObjects.add(s1);
    gameObjects.add(s2);

    gameObjects.add(player1);
    gameObjects.add(player2);

    //top boundary
    gameObjects.add(new WorldBoundary(this, new PVector(worldWidthMeters, 0), new PVector(0, 0)));
    //right boundary
    gameObjects.add(new WorldBoundary(this, new PVector(worldWidthMeters-0.1f, worldHeightMeters), new PVector(worldWidthMeters-0.1f, 0)));
  }

  public void animate(float deltaTSeconds) {

    s1.update(deltaTSeconds);
    s2.update(deltaTSeconds);


    for (GameObject o : gameObjects) {
      o.updateA(deltaTSeconds);
    }

    for (GameObject o : gameObjects) {
      o.updateV(deltaTSeconds);
    }

    for (GameObject o : gameObjects) {
      o.updateS(deltaTSeconds);
    }
    for (GameObject o : gameObjects) {
      o.handleCollisions(deltaTSeconds);
    }

    destroyBubbleOutOfBounds();
    handleUnicornOutOfScreen();
    addBubbleRatio();
  }

  public void draw() { 
    checkForGameOver();

    // draw all foreground objects. 
    for (GameObject o : gameObjects) {
      o.draw();
    }
  }


  /* void cheatRainbowMode() { //debug cheat
    if (rainbowMode == false) glitterScore=maxGlitterScore;
    else if (rainbowMode == true) setRainbowModeFalse(); 
  } */

  //deactivates RaibowMode
  public void setRainbowModeFalse() {
    rainbowMode=false;
    glitterScore=0;
    pulseCounter=0;
    unicornMode.pause(); //AUDIO
    ingame.unmute(); //AUDIO
    nightSky_ingame.unmute(); //AUDIO
  }
  //activates RainbowMode
  public void setRainbowModeTrue() {
    rainbowMode=true;
    gamePausedTime=0;
    rainbowMeterDing.pause();//AUDIO
    rainbowMeterDing.rewind();//AUDIO
    ingame.mute(); //AUDIO
    nightSky_ingame.mute(); //AUDIO
    unicornMode.play(); //AUDIO
    unicornMode.loop(); //AUDIO
    unicornMode.rewind(); //AUDIO
    rainbowTime=millis();
  }

  //player loses Live by moving out of screen
  public void handleUnicornOutOfScreen() {

    if (player1.s.x+player1.radius-0.09f<0||player1.s.y-player1.radius+0.09f>worldHeightMeters
      ||player2.s.x+player2.radius-0.09f<0||player2.s.y-player2.radius+0.09f>worldHeightMeters) {//is player out of screen?
      lives--;
      //println(lives); //Debug
      if (rainbowMode==true) {
        setRainbowModeFalse();//deactovate rainbowMode
      }
      lostHeart.play();//AUDIO
      lostHeart.rewind();//AUDIO


      //reset PlayerPos to startPos
      player1.s=startPosP1.copy();
      player2.s=startPosP2.copy();

      //if Player respawns they can't be hurt for 3sec
      saveRespawn=true;
      saveRespawnTime = millis();
    }
  }

  public void checkForGameOver() {
    if (lives<=0) {
      gameOver();
    }
  }

  public void gameOver() {      
    //saves highscore and last three scores
    if (indexAllScores < allScores.length) {
      finalScore = gameHeight;
      for (int i=scoreArray.length-2; i>=0; i--) {
        scoreArray[i+1]=scoreArray[i];
      }
      scoreArray[0] = finalScore;
      allScores[indexAllScores]  = finalScore;
      indexAllScores++;
      if (highScore < finalScore) {
        highScore = finalScore;
      }
    } else {
      indexAllScores = 0;
      finalScore = gameHeight;
      for (int i=scoreArray.length-2; i>=0; i--) {
        scoreArray[i+1]=scoreArray[i];
      }
      scoreArray[0] = finalScore;
      allScores[indexAllScores]  = finalScore;
      indexAllScores++;
      if (highScore < finalScore) {
        highScore = finalScore;
      }
    }
    gameMode=new GameEndsMode();
  }


  public void moveUnicorn(int pressedKey) {
    if (pressedKey =='w' || pressedKey == 'W') {
      player2.isMoving=true;
      player2.move(wPressed);
    }
    if (pressedKey == 's' || pressedKey == 'S') {
      player2.isMoving=true;
      player2.move(sPressed);
    }

    if (pressedKey == 'a'|| pressedKey == 'A') {
      player2.isMoving=true;
      player2.move(aPressed);
    }

    if (pressedKey == 'd'|| pressedKey == 'D') {
      player2.isMoving=true;
      player2.move(dPressed);
    }

    if (pressedKey == noPressed) {
      player2.isMoving = false;
      player2.move(noPressed);
    }
    if (pressedKey == UP) {
      player1.isMoving=true;
      player1.move(upPressed);
    }
    if (pressedKey == DOWN) {
      player1.isMoving=true;
      player1.move(downPressed);
    }

    if (pressedKey == LEFT) {
      player1.isMoving=true;
      player1.move(leftPressed);
    }

    if (pressedKey == RIGHT) {
      player1.isMoving=true;
      player1.move(rightPressed);
    }

    if (pressedKey == noPressed) {
      player1.isMoving = false;
      player1.move(noPressed);
    }
  }

  //Destroy Bubbles, Sweets, Glitter that are no longer in the map
  public void destroyBubbleOutOfBounds() {
    java.util.LinkedList<GameObject> objectsToRemove = new java.util.LinkedList<GameObject>();
    for (GameObject o : gameObjects) {
      if (o instanceof SphericalGameObject) {
        SphericalGameObject sgo=(SphericalGameObject)o;

        if (sgo instanceof Bubble) {//is bubble?
          Bubble b=(Bubble)sgo;
          if (b.s.y-b.radius>worldHeightMeters||b.s.x-b.radius>worldWidthMeters||b.s.y+b.radius<0||b.s.x+b.radius<0) {// is out of screen? ->remove Bubble
            objectsToRemove.add(b);
            bubbleCounter--;
            if (b instanceof GoodBubble) { //is Good Bubble -> also remove Sweet
              GoodBubble gb=(GoodBubble)b;
              objectsToRemove.add(gb.sweet);
            }
          }
          if (b.popped==true) { //is bubble popped ->remove Bubble    
            objectsToRemove.add(b);
            if (b instanceof GoodBubble&&lives==3) { //full lives-> also remove Sweet
              GoodBubble gb=(GoodBubble)b;
              objectsToRemove.add(gb.sweet);
            }
          }
        }
        if (sgo instanceof Sweet) {//is Sweet
          Sweet s=(Sweet)sgo;
          if (s.withoutBubble==true) {//sweet without Bubble?
            //if sweet reaches heart:
            if (s.s.y<0.22f&&s.s.x<0.22f) { 
              objectsToRemove.add(s);
              if (lives < 3) { //if lives are not full
                bubbleScore++;
                if (bubbleScore<7) {
                  heartFragment.play(); //AUDIO
                  heartFragment.rewind(); //AUDIO
                  //score counts popped bubbles
                } else if (bubbleScore >= 7) {//regain a live after eating enough sweets
                  lives++;
                  bubbleScore = 0;
                  yay.play(); //AUDIO
                  yay.rewind(); //AUDIO
                }
              }
            }
          }
        }
        if (sgo instanceof Glitter) {//is Glitter?
          Glitter g = (Glitter)sgo;
          if (g.popped == true) {//remove if Glitter is popped
            objectsToRemove.add(g);
          }
        }
      }
    }
    gameObjects.removeAll(objectsToRemove);//remove all Objects to remove

    if (bubbleCounter<numberOfBubbles) {//spawns new Bubbles, if there are less Bubbles left than numberOfBubbles
      spawnNewBubble();
    }
    if (glitterCounter<maxAmountOfGlitter) {//spawns new Glitter, if there is less Glitter left than maxAmountOfGlitter
      spawnNewGlitter();
    }
  }

  //increase Bubble Ratio when player collects more sweets to increase the difficulty
  public void addBubbleRatio() {

    if (bubbleRatioCounter*400<gameHeight && goodBadBubbleRatio<0.64f) {
      goodBadBubbleRatio+=0.03f;
      if (numberOfBubbles>8) {//decrease numberOfBubbles to keep a chance to stay alive
        numberOfBubbles--; 
        //println(numberOfBubbles);//debug
      }
      bubbleRatioCounter++;
    }
  }

//spawns new Glitter
  public void spawnNewGlitter() {
    Glitter g;
    float x = random(worldWidthMeters);      
    float y = random(worldHeightMeters);
    PImage glitterImage = glitter;
    float radius= 0.15f;
  attempts: 
    for (int attempts=0; attempts<20; attempts++) {
      for (GameObject o : gameObjects) {
        if (o instanceof Glitter) {
          Glitter glitter= (Glitter) o;
          double glitterDistance = Math.sqrt((glitter.s.x-x)*(glitter.s.x-x)+(glitter.s.y-y)*(glitter.s.y-y));
          double player1Distance= Math.sqrt((player1.s.x-x)*(player1.s.x-x)+(player1.s.y-y)*(player1.s.y-y));
          double player2Distance= Math.sqrt((player2.s.x-x)*(player2.s.x-x)+(player2.s.y-y)*(player2.s.y-y));

          if (glitterDistance<=(radius+glitter.radius+0.05f)||player1Distance<=(radius+player1.radius+0.2f)||player2Distance<=(radius+player2.radius+0.42f)) {
            x = random(worldWidthMeters);      
            y=  random(worldHeightMeters);
            continue attempts;
          }
        }
      }
      g=new Glitter(this, x, y, radius, glitterImage);
      gameObjects.add(g);
      glitterCounter++;
      break;
    }
  }

  //spawn new Bubble
  public void spawnNewBubble() {

    Bubble b;
    float random=random(0, 1);

    float x = random(worldWidthMeters);      
    float y = random(worldHeightMeters);
    float radius=random(0.2f, 0.3f);
  attempts: 
    for (int attempts=0; attempts<20; attempts++) {
      for (GameObject o : gameObjects) {
        if (o instanceof Bubble) {
          Bubble bubble= (Bubble) o;
          double bubbleDistance = Math.sqrt((bubble.s.x-x)*(bubble.s.x-x)+(bubble.s.y-y)*(bubble.s.y-y));
          double player1Distance= Math.sqrt((player1.s.x-x)*(player1.s.x-x)+(player1.s.y-y)*(player1.s.y-y));
          double player2Distance= Math.sqrt((player2.s.x-x)*(player2.s.x-x)+(player2.s.y-y)*(player2.s.y-y));

          if (bubbleDistance<=(radius+bubble.radius+0.1f)||player1Distance<=(radius+player1.radius+0.4f)||player2Distance<=(radius+player2.radius+0.4f)) {
            x = random(worldWidthMeters);      
            y=  random(worldHeightMeters);
            continue attempts;
          }
        }
      }
      if (random<goodBadBubbleRatio) {
        b= new BadBubble(this, x, y, radius, false);
        gameObjects.add(b);
        bubbleCounter++;
        break;
      } else {
        b= new GoodBubble(this, x, y, radius, false, new Sweet(this, x, y, 0.3f));
        gameObjects.add(b);
        bubbleCounter++;
        if (b instanceof GoodBubble) {
          GoodBubble gb=(GoodBubble) b;
          gameObjects.add(gb.sweet);
        }
        break;
      }
    }
  }
}
//display UI

boolean extraHeart=false;
class UI {
  GameWorld gameWorld;
  UI(GameWorld _gameWorld) {
    this.gameWorld=_gameWorld;
  }

  public void draw() {
    displayLives();
    displayScore();
    displayRainbowMeter();
    image(pressPause, gameWorld.worldWidthMeters-1.4f, -0.05f, 0.45f, 0.3f);
  }


  //display Lives
  public void displayLives() {
    float size=0.2f;
    imageMode(CENTER);
    if (gameWorld.lives>=1) {
      image(lives[8], gameWorld.worldWidthMeters/2-(size+0.05f), 0.1f, size, size);
    }
    if (gameWorld.lives>=2) {
      image(lives[8], gameWorld.worldWidthMeters/2, 0.1f, size, size);
    }
    if (gameWorld.lives>=3) {
      image(lives[8], gameWorld.worldWidthMeters/2+(size+0.05f), 0.1f, size, size);
    }
    imageMode(CORNER);

    image(lives[gameWorld.bubbleScore], 0.1f, 0.1f, size+0.2f, size+0.2f);
    if (gameWorld.bubbleScore>=7) {
      extraHeart=true;
      //gameWorld.bubbleScore=0;
    }
  }

  public void displayScore() {
    float size=0.2f;
    //calculate number positions (x,y)
    int onesPlace=(gameWorld.gameHeight%10)/1;
    int tensPlace=(gameWorld.gameHeight%100-onesPlace)/10;
    int hundredsPlace=(gameWorld.gameHeight%1000-onesPlace-tensPlace)/100;
    int thousandsPlace=(gameWorld.gameHeight%10000-onesPlace-tensPlace-hundredsPlace)/1000;
    int tenThousandsPlace=(gameWorld.gameHeight%100000-onesPlace-tensPlace-hundredsPlace-thousandsPlace)/10000;
    float x1=gameWorld.worldWidthMeters-((size-0.07f)*2);
    float x2=gameWorld.worldWidthMeters-((size-0.07f)*3);
    float x3=gameWorld.worldWidthMeters-((size-0.07f)*4);
    float x4=gameWorld.worldWidthMeters-((size-0.07f)*5);
    float x5=gameWorld.worldWidthMeters-((size-0.07f)*6);
    float xm=gameWorld.worldWidthMeters-(size-0.10f);
    float y=size-0.05f;
    //draw numbers
    imageMode(CENTER);


    if (gameWorld.gameHeight<10) {
      image(heightBackground, xm, y, size*2, size+0.1f);
      image(numbers[onesPlace], x1, y, size, size);
    }
    if (gameWorld.gameHeight<100&&gameWorld.gameHeight>=10) { 
      image(heightBackground, xm, y, size*4, size+0.1f);
      image(numbers[onesPlace], x1, y, size, size);
      image(numbers[tensPlace], x2, y, size, size);
    }
    if (gameWorld.gameHeight<1000&&gameWorld.gameHeight>=100) { 
      image(heightBackground, xm, y, size*6, size+0.1f);
      image(numbers[onesPlace], x1, y, size, size);
      image(numbers[tensPlace], x2, y, size, size);
      image(numbers[hundredsPlace], x3, y, size, size);
    }
    if (gameWorld.gameHeight<10000&&gameWorld.gameHeight>=1000) { 
      image(heightBackground, xm, y, size*8, size+0.1f);
      image(numbers[onesPlace], x1, y, size, size);
      image(numbers[tensPlace], x2, y, size, size);
      image(numbers[hundredsPlace], x3, y, size, size);
      image(numbers[thousandsPlace], x4, y, size, size);
    }
    if (gameWorld.gameHeight<100000&&gameWorld.gameHeight>=10000) { 
      image(heightBackground, xm, y, size*10, size+0.1f);
      image(numbers[onesPlace], x1, y, size, size);
      image(numbers[tensPlace], x2, y, size, size);
      image(numbers[hundredsPlace], x3, y, size, size);
      image(numbers[thousandsPlace], x4, y, size, size);
      image(numbers[tenThousandsPlace], x5, y, size, size);
    }
    image(letters[6], xm, y, size, size);
    imageMode(CORNER);
  }


  //display the rainbowMeter
  int animationCounter=0;

  public void displayRainbowMeter() {
    float x=gameWorld.worldWidthMeters-0.2f;
    float y=gameWorld.worldHeightMeters/2;
    int rainbowModeLength=12000; //length in millisec
    float size=1;
    float numberX=gameWorld.worldWidthMeters/2.0f;
    float numberY=gameWorld.worldHeightMeters/2.0f;


    imageMode(CENTER);

    if (gameWorld.glitterScore>=gameWorld.maxGlitterScore) { //is rainbowMeter full?
      //pulse rainbow Meter if it is full but not used
      if (gameWorld.pulseCounter==0&&gameWorld.rainbowMode==false) {
        rainbowMeterDing.play();//AUDIO
      }
      gameWorld.pulseCounter++;
      if (gameWorld.pulseCounter<=60&&gameWorld.pulseCounter>40) {
        tint(255, 100);
        image(rainbowMeter[5], x, y, 1, gameWorld.worldHeightMeters/2);
        noTint();
        if (gameWorld.pulseCounter>=60) {
          gameWorld.pulseCounter=0;
        }
      } else
        if (gameWorld.pulseCounter<=40) {
          image(rainbowMeter[5], x, y, 1, gameWorld.worldHeightMeters/2);
        }
      //image(rainbowMeter[5], x, y, 1, gameWorld.worldHeightMeters/2);


      if (gameWorld.rainbowMode==false) {
        if (gameWorld.keys[32]) {    //check if space is pressed to activate rainbowMode
          gameWorld.setRainbowModeTrue();//activates rainbow Mode
        }
      } else if (gameWorld.rainbowMode==true) {
        animationCounter=animationCounter+20;
        if (animationCounter>850) {
          animationCounter=0;
        }

        image(rainbowMeterMode[animationCounter/100], x, y, 1, gameWorld.worldHeightMeters/2);


        float timeRainbowModeIsOn=millis()-(gameWorld.rainbowTime+gameWorld.gamePausedTime);//calculates time RainbowMode is already activate
        //println(millis()-(rainbowTime+gameWorld.gamePausedTime));//debug
        //counts down 3 sec before rainbow Mode stops
        if (timeRainbowModeIsOn>rainbowModeLength-3000&&timeRainbowModeIsOn<rainbowModeLength-2000) {
          image(numbers[3], numberX, numberY, size, size);
        }
        if (timeRainbowModeIsOn>rainbowModeLength-2000&&timeRainbowModeIsOn<rainbowModeLength-1000) {
          image(numbers[2], numberX, numberY, size, size);
        }
        if (timeRainbowModeIsOn>rainbowModeLength-1000&&timeRainbowModeIsOn<rainbowModeLength) {
          image(numbers[1], numberX, numberY, size, size);
        }
        if (timeRainbowModeIsOn>=rainbowModeLength) {//deactivate rainbowMode after 12sec
          gameWorld.setRainbowModeFalse();
        }
      }
    } else {
      //draw rainbowMeter halffull
      switch(gameWorld.glitterScore) {
      case 0:
        image(rainbowMeter[0], x, y, 1, gameWorld.worldHeightMeters/2);
        break;
      case 1:
        image(rainbowMeter[1], x, y, 1, gameWorld.worldHeightMeters/2);
        break;
      case 2:
        image(rainbowMeter[2], x, y, 1, gameWorld.worldHeightMeters/2);
        break;
      case 3:
        image(rainbowMeter[3], x, y, 1, gameWorld.worldHeightMeters/2);
        break;
      case 4:
        image(rainbowMeter[4], x, y, 1, gameWorld.worldHeightMeters/2);
        break;
      }
    }

    imageMode(CORNER);
  }
}
// Unicorns aka Player 1 and 2
class Unicorn extends SphericalGameObject {

  float mass; // in kg
  boolean isMoving=false; // checks if unicorn is moving
  PImage icon;
  float startSpeed=0;
  int counter=0;//respawn pulse counter
  int rainbowCounter=0;
  int animationCounter=0;
  int rainbowColor=0;


  Unicorn(GameWorld _gameWorld, float x, float y, PImage _icon) {
    super(_gameWorld, x, y, 0.17f);
    mass = 0.1f;
    this.icon=_icon;
  }

  public void draw() {
    stroke(0xff785151);
    strokeWeight(0.01f);

    imageMode(CENTER);

    if (gameWorld.saveRespawn==true&&gameWorld.rainbowMode==false) {
      //pulse unicorn while respawning
      counter++;
      //  println(counter); //debug
      if (counter<=60&&counter>40) {
        tint(255, 100);
        stroke(0xff770000, 50);
        if (this==gameWorld.player1) {
          line(gameWorld.player1.s.x, gameWorld.player1.s.y, gameWorld.player2.s.x, gameWorld.player2.s.y);
        }
        image(icon, s.x, s.y, radius, radius);
        noTint();
        if (counter>=60) {
          counter=0;
        }
      }
      if (counter<=40) {
        if (this==gameWorld.player1) {
          line(gameWorld.player1.s.x, gameWorld.player1.s.y, gameWorld.player2.s.x, gameWorld.player2.s.y);
        }
        image(icon, s.x, s.y, radius, radius);
      }
    } else if (gameWorld.rainbowMode==true) { //rainbow unicorns if rainbow mode is activated

      rainbowCounter++;
      //println(rainbowCounter); //Debug
      animationCounter=animationCounter+20;
      if (animationCounter>850) {
        animationCounter=0;
      }
      if (this==gameWorld.player1) {
        line(gameWorld.player1.s.x, gameWorld.player1.s.y, gameWorld.player2.s.x, gameWorld.player2.s.y);
      }
      image(rainbowUnicorn[animationCounter/100], s.x, s.y, radius, radius);
    } else {
      noTint();
      if (this==gameWorld.player1) {
        line(gameWorld.player1.s.x, gameWorld.player1.s.y, gameWorld.player2.s.x, gameWorld.player2.s.y);
      }
      image(icon, s.x, s.y, radius, radius);
    }
    imageMode(CORNER);
  }

  public void move(int pressedKey) {

    //if no keyPressed: unicorn moves leftdown
    if (pressedKey == noPressed) {
      v.add(PVector.mult(new PVector(-1, 1), 0.001f));
    } 

    //set unicorn speed
    if (gameWorld.rainbowMode==true) { //faster if rainbowMode is active
      startSpeed=0.02f;
      gameWorld.speed=startSpeed;
    } else {
      startSpeed=0.012f;
      gameWorld.speed=startSpeed;
      
    }
    //moves unicorns if wasd/ ULRD are pressed
    if (pressedKey == 'w'|| pressedKey == 'W') {
      v.add(PVector.mult(new PVector(0, 1), -gameWorld.speed));
    }
    if (pressedKey == 'a'|| pressedKey == 'A') {
      v.add(PVector.mult(new PVector(1, 0), -gameWorld.speed));
    }
    if (pressedKey == 's'|| pressedKey == 'S') {
      v.add(PVector.mult(new PVector(0, 1), gameWorld.speed));
    }
    if (pressedKey == 'd'|| pressedKey == 'D') {
      v.add(PVector.mult(new PVector(1, 0), gameWorld.speed));
    }
    if (pressedKey == UP) {
      v.add(PVector.mult(new PVector(0, 1), -gameWorld.speed));
    }
    if (pressedKey == LEFT) {
      v.add(PVector.mult(new PVector(1, 0), -gameWorld.speed));
    }
    if (pressedKey == RIGHT) {
      v.add(PVector.mult(new PVector(1, 0), gameWorld.speed));
    }
    if (pressedKey == DOWN) {
      v.add(PVector.mult(new PVector(0, 1), gameWorld.speed));
    }
  }


  //handle distance of Unicorns through springs 

  public void applyForce(PVector force, float deltaTimeSeconds) {
    float dampingFactor = 0.1f;
    PVector f = force;
    if (a.mag() >= 0.5f) {
    a.mult(pow(dampingFactor, deltaTimeSeconds));
    } else {
      f.div(mass*2);
      a.add(f);
    }
  }

//credits: to prof. Fuchs (code example: marbles)
  public void handleSphericalGameObjectCollision(SphericalGameObject sgo, 
    float deltaTimeSeconds) {

    /** Unicorn-Unicorn collisions */

    if (objectID >= sgo.objectID) { // make sure to check collisions only once 
      return;
    }
    if (! (sgo instanceof Unicorn)) { // we are only interested in Unicorn-Unicorn collisions
      return;
    }
    Unicorn u = (Unicorn) sgo;

    // set up the quadratic equation
    PVector x = PVector.sub(s, u.s);
    PVector y = PVector.sub(u.v, v);
    float z = radius-0.07f + u.radius-0.07f;

    float a = PVector.dot(y, y);
    float b = 2 * PVector.dot(x, y);
    float c = PVector.dot(x, x) - z*z;

    float discriminant = b*b-4*a*c;

    float t; // we want to compute

    if (abs(a) < MIN_COLLISION_EPSILON) { // degenerate case: just a linear equation
      if (abs(b) < MIN_COLLISION_EPSILON) {
        // constant equation ? either true statement for all choices of t (constantly in touch) or false for any = either way, no collision for us to treat.
        return;
      }
      t = -c / b;
      if (t < 0) { // negative means: solution in the future - discard.
        return;
      }
      if (t >= deltaTimeSeconds) { // solution occurs too far in the past
        return;
      }
    } else { // quadratic equation

      if (discriminant < 0) {
        return; // no solutiuons
      }

      float sqd = sqrt(discriminant);

      // solutions (by design, t1 <= t2):

      float t1 = (-b - sqd ) / (2.0f * a);
      float t2 = (-b + sqd ) / (2.0f * a);

      if (t2 < 0) { // both solutions negative - both in the future - discard.
        return;
      }
      if (t1 >= deltaTimeSeconds) { // both solutions occur too far in the past
        return;
      }

      // we need the earlier solution that happened in this timestep.

      t = (t2 < deltaTimeSeconds) ? t2 : t1;
    }

    if (t >= deltaTimeSeconds) { // collision was in the past
      return;
    }

    // update velocities =======================================

    PVector vold1Vector = v.copy();
    PVector vold2Vector = u.v.copy();

    PVector s1coll = PVector.sub(s, PVector.mult(v, t));
    PVector s2coll = PVector.sub(u.s, PVector.mult(u.v, t));
    PVector d = PVector.sub(s2coll, s1coll).normalize();    

    float v1old = PVector.dot(v, d);
    float v2old = PVector.dot(u.v, d);

    float deltaV = 6.0f * (mass * v1old + u.mass * v2old) / (mass + u.mass);

    float v1new = deltaV - v1old;
    float v2new = deltaV - v2old;

    v.add(PVector.mult(d, v1new-v1old*2.0f));
    u.v.add(PVector.mult(d, v2new-v2old*2.0f));

    s.add(PVector.mult(vold1Vector, -t));
    s.add(PVector.mult(v, t));

    u.s.add(PVector.mult(vold2Vector, -t));
    u.s.add(PVector.mult(u.v, t));
  }

  public void handleDistance(SphericalGameObject sgo, float deltaTimeSeconds) {

    if (objectID >= sgo.objectID) { // make sure to check collisions only once 
      return;
    }
    if (! (sgo instanceof Unicorn)) { // we are only interested in Unicorn-Unicorn collisions
      return;
    }    
    PVector distance = PVector.sub(s, sgo.s);
    float lengthUnicornDistance = distance.mag();
    if (lengthUnicornDistance > 0.5f) {

      PVector vold1 = sgo.v.copy();

      sgo.v.y = -vold1.y; //* (-1.6);
      sgo.v.x = -vold1.x; //* (-1.6);

      sgo.s.add(PVector.mult(vold1, 0.5f));
      sgo.s.add(PVector.mult(sgo.v, 0.5f));

      PVector vold2 = v.copy();

      v.y = -vold2.y; //* (-1.6);
      v.x = -vold2.x; // * (-1.6);

      s.add(PVector.mult(vold2, 0.5f));
      s.add(PVector.mult(v, 0.5f));
    }
  }
}
class UnicornGame extends GameMode {

  GameWorld gameWorld;
  UI ui;
  int noPressed;
  int ruckelCounter=0;
  float timeCounter=0;

  float gameSpeed=1;//counts the game Speed
  float heightCounter=0;//counts the height of the game
  float startSaveCounter=0;//counts length of save spawn at the start of the game
  boolean pauseGame=false; //checks if game is Paused
  boolean keyIsReleased=true; //checks if key is still Pressed

  int millisAtGameStart;


  // UI attributes ===================================================================

  // last time draw() was called - for animations
  int millisDrawWasLastCalled;


  // constructor and methods =========================================================

  UnicornGame() {
    millisDrawWasLastCalled = millis();  
    gameWorld = new GameWorld();
    ui=new UI(gameWorld);
    millisAtGameStart=millis();    
    homeScreen.pause(); //AUDIO
    homeScreen.rewind();//AUDIO
    ingame.play(); //AUDIO
    ingame.loop(); //AUDIO
    gameWorld.glitterScore=0;
  }

  //modify keyPressed and keyReleased
  public void keyPressed() {
    if (keyCode>255) return; 
    gameWorld.keys[keyCode] = true;
    // System.out.println (keyCode); //debug
    if (key>255) return;
    gameWorld.keys[key] = true;
  }

  public void keyReleased() {
    if (keyCode>255) return;
    gameWorld.keys[keyCode] = false;
    // System.out.println ("!" + keyCode); //debug
    if (key>255) return;
    gameWorld.keys[key] = false;
  }

  public void draw() {
    pauseGame();
    int millisNow = millis();
    float timeElapsed = (millisNow - millisDrawWasLastCalled) / 1000.0f; // since the last frame, in seconds.

    //makes sure that every TimeStep is the same
    if (timeElapsed>0.1f) {
      println("ruckelt"); 
      timeElapsed=0.1f;
      if (ruckelCounter<1) { //make sure that game starts at startSpeed, even if game start is delayed
        ruckelCounter++;
        millisAtGameStart=millis();
      }
    }
    if (pauseGame==false) {// normal game play

      startSaveCounter+=timeElapsed;
      updateSpeed(timeElapsed);

      if (startSaveCounter<2.5f) {//saveRespawn at the beginning of the game
        gameWorld.saveRespawn=true;
      } else if (millis()-gameWorld.saveRespawnTime>3000&&(startSaveCounter>2.5f)) {//ends every save Respawn
        gameWorld.saveRespawn=false;
      }


      //set GameWorld coordinates
      pushMatrix(); 

      scale( width/(float) gameWorld.worldWidthMeters, height/(float) gameWorld.worldHeightMeters);

      //if a key is pressed the Unicorn has to move
      if (gameWorld.keys['w'] || gameWorld.keys['W']) gameWorld.moveUnicorn('w');
      if (gameWorld.keys['a'] || gameWorld.keys ['A']) gameWorld.moveUnicorn('a');
      if (gameWorld.keys ['s'] || gameWorld.keys ['S']) gameWorld.moveUnicorn('s');
      if (gameWorld.keys ['d'] || gameWorld.keys ['D']) gameWorld.moveUnicorn('d');

      //if no key is pressed the Unicorn stops its movement
      if (gameWorld.keys['w'] == false || gameWorld.keys['W'] == false) gameWorld.moveUnicorn(noPressed);
      if (gameWorld.keys['a'] == false || gameWorld.keys ['A'] == false) gameWorld.moveUnicorn(noPressed);
      if (gameWorld.keys ['s'] == false || gameWorld.keys ['S'] == false) gameWorld.moveUnicorn(noPressed);
      if (gameWorld.keys ['d'] == false || gameWorld.keys ['D'] == false) gameWorld.moveUnicorn(noPressed);

      //if a key is pressed the Unicorn has to move
      if (gameWorld.keys[UP]) gameWorld.moveUnicorn(UP);
      if (gameWorld.keys[LEFT]) gameWorld.moveUnicorn(LEFT);
      if (gameWorld.keys [DOWN]) gameWorld.moveUnicorn(DOWN);
      if (gameWorld.keys [RIGHT]) gameWorld.moveUnicorn(RIGHT);

      //if no key is pressed the Unicorn stops its movement
      if (gameWorld.keys[UP] == false) gameWorld.moveUnicorn(noPressed);
      if (gameWorld.keys[LEFT] == false) gameWorld.moveUnicorn(noPressed);
      if (gameWorld.keys [DOWN] == false) gameWorld.moveUnicorn(noPressed);
      if (gameWorld.keys [RIGHT] == false) gameWorld.moveUnicorn(noPressed);

      //cheats just for fun
   //   if (gameWorld.keys ['R'] == true || gameWorld.keys ['r'] == true) gameWorld.cheatRainbowMode();

      // draw, in the Processing world, includes updating the game state - hence, animate all objects from draw()
      gameWorld.animate(timeElapsed);

      gameWorld.draw();
      ui.draw();

      popMatrix();
    } else if (pauseGame==true) {//pause Screen, game stops     
      if (gameWorld.rainbowMode==true) {//makes sure that rainbowCount stops while game is paused
        gameWorld.gamePausedTime+=(millisNow-millisDrawWasLastCalled);
      }
    }
    millisDrawWasLastCalled = millisNow;
  }

  //pause Modus
  public void pauseGame() {
    if (keyIsReleased==true&&pauseGame==true) { 
      if (gameWorld.keys[82]) {//restart game
        gameMode=new GameLoadsMode();
      } 
      if (gameWorld.keys[80]) {//continue gameplay
        pauseGame=false;
        keyIsReleased=false;
        if (gameWorld.rainbowMode==true) {
          unicornMode.play();//AUDIO
        } else if (gameWorld.gameHeight<gameWorld.background.darkBlueHeight) {
          ingame.unmute();//AUDIO
        } else if (gameWorld.gameHeight>gameWorld.background.darkBlueHeight) {
          nightSky_ingame.unmute();//AUDIO
        }
      }
    } else if (keyIsReleased==true&&pauseGame==false) {
      if (gameWorld.keys[80]) {//pause gameplay
        pauseGame=true;
        image(pauseScreen, 0, 0, width, height);
        keyIsReleased=false;
        if (gameWorld.rainbowMode==true) {
          unicornMode.pause();//AUDIO
        } else if (gameWorld.gameHeight<gameWorld.background.darkBlueHeight) {
          ingame.mute();//AUDIO
        } else if (gameWorld.gameHeight>gameWorld.background.darkBlueHeight) {
          nightSky_ingame.mute();//AUDIO
        }
      }
    } 
    if (gameWorld.keys[80]==false) {
      keyIsReleased=true;
    }
  }

  public void updateSpeed(float deltaTimeSeconds) {
    //update gameSpeed
    timeCounter=0.05f;
    gameSpeed+=(timeCounter*deltaTimeSeconds);

    if (gameWorld.rainbowMode==false) {
      gameWorld.updateSpeed=gameSpeed;//set updateSpeed variable
      heightCounter+=(gameWorld.updateSpeed); //update Height counter
    } else if (gameWorld.rainbowMode==true) {
      gameWorld.updateSpeed=gameSpeed+gameWorld.rainbowSpeed;//set updateSpeed variable in rainbowMode
      heightCounter+=(gameWorld.updateSpeed);//update Height counter
    }

    if (gameWorld.updateSpeed<1) {//speed is at least 1
      gameWorld.updateSpeed=1;
    }
    //println(gameWorld.updateSpeed);//Debug
    // println(gameHeight);//Debug
    gameWorld.gameHeight=(int)(heightCounter/50); //set final game height
    // println(gameWorld.gameHeight); //debug
    // println(gameWorld.goodBadBubbleRatio);//debug
  }


  //method to get gameWorld coordinates from pixels
  public PVector pixelsToGameWorldCoordinates(int x, int y) {
    return new PVector((x - width/2) 
      / (float) width * gameWorld.worldWidthMeters, 
      (y - height / 2)
      / (float) height * gameWorld.worldHeightMeters );
  }
}
  static public void main(String[] passedArgs) {
    String[] appletArgs = new String[] { "SugarHeist" };
    if (passedArgs != null) {
      PApplet.main(concat(appletArgs, passedArgs));
    } else {
      PApplet.main(appletArgs);
    }
  }
}
