import ddf.minim.*;

GameMode gameMode;

//declare IMAGES
PImage lolli, bonbon, schoki;
PImage skyPink, skyLightBlue, skyDarkBlue, universeSky;
PImage glitter, glitterRepulsion;

PImage horizontalClouds, verticalClouds;
PImage goodBubble, badBubble;
PImage heightBackground;
PImage pressPause;


//images for menu
PImage loadingScreen; 
PImage pauseScreen; 
PImage credits;
PImage [] menu=new PImage[7];
PImage [] handbook=new PImage[7];
PImage [] customizeScreen=new PImage[2];
PImage [] gameOverScreen=new PImage[3];


//images for custom font
PImage[] numbers=new PImage[10];
PImage [] letters=new PImage[12];

//images unicorn
PImage [] unicornsBig=new PImage[14];
PImage [] unicornsSmall=new PImage[14];
PImage[] rainbowUnicorn=new PImage[9];

//images for UI
PImage[] rainbowMeter=new PImage[6];
PImage[] rainbowMeterMode=new PImage[9];
PImage [] lives=new PImage[9];


//declare AUDIO files
Minim minim;
AudioPlayer popBubble, glitterSound, badBubblePlop, yay, gameOver, lostHeart, rainbowMeterDing;
AudioPlayer homeScreen, ingame, unicornMode, nightSky_ingame, heartFragment;

//Score variables
int finalScore;
int indexScoreArray = 0;
int indexAllScores = 0;
int highScore = 0;
int[] scoreArray = new int[3];
int[] allScores = new int[30];

//custom Unicorn variables
int indexPlayer1=0;
int indexPlayer2=1;
PImage player1Icon, player2Icon;



void settings() {

  PJOGL.setIcon("unicornsSmall/11.png");

  //set Screen size
  fullScreen("processing.opengl.PGraphics2D");
  //size(1920, 1080, "processing.opengl.PGraphics2D");
  //size(1280, 720, "processing.opengl.PGraphics2D");
}

void setup() {
  // set no mouse Cursor
  noCursor();

  frameRate(60);
  surface.setTitle("SugarHeist");


  //load Loading Screen Image
  loadingScreen= loadImage("loadScreen.png");

  image(loadingScreen, 0, 0, width, height);

  for (int i=0; i<unicornsSmall.length; i++) {
    unicornsSmall[i] = loadImage ("unicornsSmall/"+i+".png");
  }

  player1Icon=unicornsSmall[indexPlayer1];
  player2Icon=unicornsSmall[indexPlayer2];



  //Setup Audio Library
  minim = new Minim(this);

  homeScreen = minim.loadFile("sounds/buddy.mp3"); //Royalty Free Soundtrack from bensound "buddy"
  homeScreen.setGain(-15);


  //set StartScreen
  gameMode = new HomeMode();
  homeScreen.play(); //AUDIO
  homeScreen.loop(); //AUDIO
}

boolean needsToPreload=true;

void draw() {
  //preloads and loads Images 1 time
  if (needsToPreload==true) {
    image(loadingScreen, 0, 0, width, height);
    loadFiles();
    preloadImages();
    needsToPreload=false;
  }

  gameMode.draw();
}


void mouseClicked() {
  gameMode.mouseClicked();
}
void keyPressed() {
  gameMode.keyPressed();
}
void keyReleased() {
  gameMode.keyReleased();
}
void mousePressed() {
  gameMode.mousePressed();
}
void mouseReleased() {
  gameMode.mouseReleased();
}



//Image all Images so it works smoothly later
void preloadImages() {
  for (int i=0; i<numbers.length; i++) {
    image(numbers[i], 0, 0, 0.01, 0.01);
  }
  image(loadingScreen, 0, 0, width, height);
  for (int i=0; i<letters.length; i++) {
    image(letters[i], 0, 0, 0.01, 0.01);
  }
  image(loadingScreen, 0, 0, width, height);
  for (int i=0; i<rainbowUnicorn.length; i++) {
    image(rainbowUnicorn[i], 0, 0, 0.01, 0.01);
  }
  image(loadingScreen, 0, 0, width, height);

  for (int i=0; i<rainbowMeter.length; i++) {
    image(rainbowMeter[i], 0, 0, 0.01, 0.01);
  }
  image(loadingScreen, 0, 0, width, height);
  for (int i=0; i<lives.length; i++) {
    image(lives[i], 0, 0, 0.01, 0.01);
  }
  image(loadingScreen, 0, 0, width, height);
  for (int i=0; i<rainbowMeterMode.length; i++) {
    image(rainbowMeterMode[i], 0, 0, 0.01, 0.01);
  }
  image(loadingScreen, 0, 0, width, height);
  for (int i=0; i<gameOverScreen.length; i++) {
    image(gameOverScreen[i], 0, 0, 0.01, 0.01);
  }
  image(loadingScreen, 0, 0, width, height);
}


//load all data
void loadFiles() {

  //IMAGE FILES
  bonbon = loadImage ("bonbon.png");
  lolli = loadImage ("lolli.png");
  schoki = loadImage ("schoki.png");

  skyPink = loadImage ("rosaSky.jpg");
  skyLightBlue= loadImage ("blueSky.jpg");
  skyDarkBlue= loadImage ("nightSky.jpg");
  universeSky= loadImage("universeSky.jpg");

  heightBackground= loadImage("heightBackground.png");
pressPause= loadImage("pressPause.png");

  pauseScreen= loadImage("pauseScreen.png");
  credits=loadImage ("menu/credits.png");


  glitter = loadImage ("glitter.png");
  glitterRepulsion = loadImage ("glitterRepulsion.png");


  horizontalClouds = loadImage ("horizontalClouds.png");
  verticalClouds = loadImage ("verticalClouds.png");
  badBubble = loadImage ("badBubble.png");
  goodBubble = loadImage ("goodBubble.png");

  for (int i=0; i<rainbowUnicorn.length; i++) {
    rainbowUnicorn[i] = loadImage ("rainbowUnicorn/"+i+".png");
  }

  for (int i=0; i<rainbowMeter.length; i++) {
    rainbowMeter[i] = loadImage ("rainbowMeter/"+i+".png");
  }
  for (int i=0; i<lives.length; i++) {
    lives[i] = loadImage ("lives/"+i+".png");
  }
  for (int i=0; i<rainbowMeterMode.length; i++) {
    rainbowMeterMode[i] = loadImage ("rainbowMeter/rainbowMeterMode/"+i+".png");
  }

  for (int i=0; i<numbers.length; i++) {
    numbers[i] = loadImage ("numbers/"+i+".png");
  }
  for (int i=0; i<letters.length; i++) {
    letters[i] = loadImage ("letters/"+i+".png");
  }

  for (int i=0; i<menu.length; i++) {
    menu[i] = loadImage ("menu/"+i+".png");
  }
  for (int i=0; i<handbook.length; i++) {
    handbook[i] = loadImage ("handbook/"+i+".png");
  }

  for (int i=0; i<gameOverScreen.length; i++) {
    gameOverScreen[i] = loadImage ("gameOver/"+i+".png");
  }

  for (int i=0; i<customizeScreen.length; i++) {
    customizeScreen[i] = loadImage ("customizeScreen/"+i+".png");
  }

  // AUDIO FILES and set Gain
  popBubble = minim.loadFile("sounds/plop.mp3");
  popBubble.setGain(12);
  glitterSound = minim.loadFile ("sounds/glitter.mp3");
  glitterSound.setGain(-20);
  badBubblePlop = minim.loadFile ("sounds/badBubbleplop.mp3");
  unicornMode=minim.loadFile("sounds/PFUDOR_.mp3"); //Common License Soundtrack from bensounds "happy rock"
  unicornMode.setGain(-11);

  ingame = minim.loadFile("sounds/sunny.mp3"); //Common License Soundtrack from bensounds "sunny"
  ingame.setGain(-15);
  yay = minim.loadFile("sounds/yay.mp3"); //later use as audio for the extra heart gain
  yay.setGain(+20);
  gameOver = minim.loadFile("sounds/gameOver.mp3");
  gameOver.setGain(-15);
  lostHeart = minim.loadFile("sounds/losing_a_heart.mp3");
  lostHeart.setGain(-10);
  rainbowMeterDing = minim.loadFile("sounds/airplane_beep.mp3"); //Sponsored by Airplane Sounds from Lufthansa
  rainbowMeterDing.setGain (-9);
  nightSky_ingame = minim.loadFile ("sounds/cute.mp3"); //Common License Soundtrack from bensounds "cute"
  nightSky_ingame.setGain(-10);
  heartFragment = minim.loadFile ("sounds/heartFragment.mp3"); 
  heartFragment.setGain (-6);
}
